'use strict';

let querystring = require('querystring');
let request = require('request');
let S = require('string');

exports.search = search;

const baseUrl = 'http://itunes.apple.com/search?';

function search(term, options, callback) {
  if (!term) {
    callback({ text: 'search term is required' });
    return;
  }

  options = options ? options : {};

  options.term = term;

  let url = baseUrl + querystring.stringify(options);

  request(url, requestCallback);

  function requestCallback(err, header, res) {
    if (err) {
      callback(err);
      return;
    }

    try {
      let data = JSON.parse(res);
      data.term = term;
      callback(null, data);
    } catch (e) {
      callback({
        error: e,
        text: S(S(res).stripTags().s).replaceAll('  ', ' ').s.substring(5),
      });
    }
  }
}
